/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package honoursproj;
import java.io.*;
import java.util.*;
import java.sql.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 *
 * @author N.D
 */
public class HonoursProj {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException 
    {
        
         
         System.out.print("Enter a sentence to spellcheck=> ");
         Scanner scn=new Scanner(System.in); 
         String searchstring,input= scn.nextLine();
         long lStartTime = System.currentTimeMillis();
         
	 String misW = preprocessin(input);
         if(misW.equals(""))
         {
             System.out.println("All words were correctly spelled");
         }
         else
         {
         StringTokenizer ErrorDWords= new StringTokenizer(misW);
         int numberoftokens = ErrorDWords.countTokens();
         for(int i =0;i<numberoftokens;i++)
         {
            searchstring = ErrorDWords.nextToken();
            boolean check=errordetection(searchstring); 
            if(check)
            {
                 System.out.println(searchstring + " is correctly spelled");
            }
            else
            {
                 System.out.println( searchstring + " is wrongly spelled");
            }
       
         }
         }
         long lEndTime = System.currentTimeMillis();
         long difference = lEndTime - lStartTime;
         System.out.println("Elapsed milliseconds: " + difference);
        
               
         
    }
         
         
    private static final HashMap<String,String> sqlTokens;
    private static Pattern sqlTokenPattern;

static
{           
    //MySQL escape sequences: http://dev.mysql.com/doc/refman/5.1/en/string-syntax.html
    String[][] search_regex_replacement = new String[][]
    {
                //search string     search regex        sql replacement regex
            //{   "\u0000"    ,       "\\x00"     ,       "\\\\0"     },
            {   "'"         ,       "'"         ,       "\\\\'"     }
            //{   "\""        ,       "\""        ,       "\\\\\""    },
            //{   "\b"        ,       "\\x08"     ,       "\\\\b"     },
            //{   "\n"        ,       "\\n"       ,       "\\\\n"     },
            //{   "\r"        ,       "\\r"       ,       "\\\\r"     },
            //{   "\t"        ,       "\\t"       ,       "\\\\t"     },
            //{   "\u001A"    ,       "\\x1A"     ,       "\\\\Z"     },
            //{   "\\"        ,       "\\\\"      ,       "\\\\\\\\"  }
    };

    sqlTokens = new HashMap<String,String>();
    String patternStr = "";
    for (String[] srr : search_regex_replacement)
    {
        sqlTokens.put(srr[0], srr[2]);
        patternStr += (patternStr.isEmpty() ? "" : "|") + srr[1];            
    }
    sqlTokenPattern = Pattern.compile('(' + patternStr + ')');
}

//escape strings
public static String escape(String s)
{
    Matcher matcher = sqlTokenPattern.matcher(s);
    StringBuffer sb = new StringBuffer();
    while(matcher.find())
    {
        matcher.appendReplacement(sb, sqlTokens.get(matcher.group(1)));
    }
    matcher.appendTail(sb);
    return sb.toString();
}
    //Preprocesssing algorithm 
   public static String preprocessin(String str) throws IOException
   {
       String searchstring, store;
       StringBuilder builder = new StringBuilder();
       StringTokenizer sTok = new StringTokenizer(str.toLowerCase());
       
        try
        {
            int numberoftokens = sTok.countTokens();
            for(int i = 0; i < numberoftokens;i++) 
             {
                 searchstring = sTok.nextToken();
                 //while(found!=true&& input.hasNext())
                 // {
                     // found = search.equals(input.next());  
                  //}
                  int count = search(searchstring,"ukwebalanacorpus.txt");
                  if(count == 0)
                  {
                      builder.append(searchstring);
                      builder.append(" ");
                  }
            }     
        }
            
        catch(FileNotFoundException e)
        {
            System.err.format("File does not exist\n");
        }
        store = builder.toString(); 
        return store;
   }
   ////generates word trigram and their frequencies. stored in a database
   public static void trigramFre() throws IOException
   {
       java.io.File file;
       file = new java.io.File("langacorpus.txt");
        //File file1 = new java.io.File("output.txt");
       FileWriter f = new FileWriter("outputlanga.txt");     
       try
       {
           Class.forName("com.mysql.jdbc.Driver").newInstance(); 
           Connection conn = DriverManager.getConnection( "jdbc:mysql://localhost:3306/corpuszulu", "root", "");
           Statement st = conn.createStatement();
           Scanner input = new Scanner(file);
           while(input.hasNext())
           {
               String str, store = input.next();
               int pos =0;
               if(store.length()>=3)
               {
               while(pos <store.length())
               {
                   if((pos+3)>=store.length())
                   {
                     str=store.substring(pos, store.length());
                     pos=store.length();
                   }
                   else
                   {
                     str = store.substring(pos, pos+3); 
                     pos=pos+1;
                   }
                   //System.out.println(str);
                  //file1 = new java.io.File("output.txt");
                    int k = search(str,"langacorpus.txt");
                   //System.out.println(k);
                   f.write(escape(str) + "\t" + k + "\r\n");
                   //f.write(str + " ");
             
                  //int start= st.executeUpdate("UPDATE tri3 SET frequency=frequency+0 WHERE word='"+str+"'");
                  //if(start!=1)
                  //{
                   // int val1 = st.executeUpdate("INSERT into tri3 VALUES('"+str+"',"+k+")");
                 // }
                   

               }
             }
               
           }
           f.close();
           System.out.println("Got here");
           conn.close();
       }
       catch(Exception e)
        {
            e.printStackTrace();
        }
       
   }
   //generates word bigram and their frequencies. stored in a database
 public static void bigramFre()
         
   {
       java.io.File file;
       file = new java.io.File("output.txt");
       try
       {
           Class.forName("com.mysql.jdbc.Driver").newInstance(); 
           Connection conn = DriverManager.getConnection( "jdbc:mysql://localhost:3306/corpuszulu", "root", "");
           Statement st = conn.createStatement();
           Scanner input = new Scanner(file);
           while(input.hasNext())
           {
               String str, store = input.next();
               int pos =0;
               while(pos <store.length())
               {
                   if((pos+3)>=store.length())
                   {
                     str = store.substring(pos, store.length());
                     pos=store.length();
                     
                   }
                   else
                   {
                     str = store.substring(pos, pos+3);
                     int start= st.executeUpdate("UPDATE trigram SET frequency=frequency+1 WHERE TriWord='"+str+"'");
                     if(start!=1)
                     {
                       int val1 = st.executeUpdate("INSERT into trigram VALUES('"+str+"',"+1+")");
                     }
                     pos=pos+1;
                   }
               }
               
           }
          //System.out.println(r);
          conn.close();
       }
       catch(Exception e)
        {
            e.printStackTrace();
        }
       
   }
 //generates word unigram and their frequencies. stored in a database
 public static void unigramFre()
   {
       java.io.File file;
       file = new java.io.File("zulu.txt");
       try
       {
            Class.forName("com.mysql.jdbc.Driver").newInstance(); 
            Connection conn = DriverManager.getConnection( "jdbc:mysql://localhost:3306/corpuszulu", "root", "");
            Statement st = conn.createStatement();
            Scanner input = new Scanner(file);
           while(input.hasNext())
           {
                String store = input.next();
                int start= st.executeUpdate("UPDATE unigram SET frequency=frequency+1 WHERE uword='"+store+"'");
                if(start!=1)
                {
                    int val1 = st.executeUpdate("INSERT into unigram VALUES('"+store+"',"+1+")");
                }
                    
                /*
               //int val1 = st.executeUpdate("INSERT into unigram VALUES('"+store+"',"+1+")"); 
               
                }*/
           }
          conn.close(); 
       }
       catch(Exception e)
        {
            e.printStackTrace();
        }
       
   }
 //Retrieves the unigram counts from the database  
 public static int getUnigramCount(String word)
   {
       int count = 0;
       try
       {
         Class.forName("com.mysql.jdbc.Driver").newInstance(); 
         Connection conn = DriverManager.getConnection( "jdbc:mysql://localhost:3306/corpuszulu", "root", "");
         Statement st = conn.createStatement();
         ResultSet val = st.executeQuery("SELECT * FROM unigram WHERE wordu= '"+word+"'");
         while(val.next())
          {
             count=val.getInt("frequency");
          }
         
         conn.close();
       }
       catch (Exception e) 
       {
		  e.printStackTrace(); 
       }
       return count;
   
   }
   //Retrieves the bigram frequncies from the database
   public static int getBigramCount(String word)
   {
       int count = 0;
       try
       {
         Class.forName("com.mysql.jdbc.Driver").newInstance(); 
         Connection conn = DriverManager.getConnection( "jdbc:mysql://localhost:3306/corpuszulu", "root", "");
         Statement st = conn.createStatement();
         ResultSet val = st.executeQuery("SELECT * FROM bigram WHERE wordu= '"+word+"'");
         while(val.next())
          {
             count=val.getInt("frequency");
          }
         
         conn.close();
       }
       catch (Exception e) 
       {
		  e.printStackTrace(); 
       }
       return count;
   
   }
    public static ArrayList<String> WordBigram(String word)
   {
               ArrayList<String> strBi= new ArrayList<String>();
               int pos =0;
               while(pos <word.length())
               {
                   if((pos+2)>=word.length())
                   {
                     strBi.add(word.substring(pos,word.length()-1));
                     pos=word.length();
                   }
                   else
                   {
                     strBi.add(word.substring(pos, pos+2));
                     pos=pos+2;
                   }
               }
           return strBi;    
    }

   public static ArrayList<String> WordTrigram(String word)
   {
       
               ArrayList<String> strTri= new ArrayList<String>();
               int pos =0;
               while(pos <word.length())
               {
                   if((pos+3)>=word.length())
                   {
                     strTri.add(word.substring(pos,word.length()-1));
                     pos=word.length();
                   }
                   else
                   {
                     strTri.add(word.substring(pos, pos+3));
                     pos=pos+3;
                   }
               }
           return strTri;    
    }
   //Retrieves the trigram counts from the database 
   public static int getTrigramCount(String word)
   {
       int count = 0;
       try
       {
         Class.forName("com.mysql.jdbc.Driver").newInstance(); 
         Connection conn = DriverManager.getConnection( "jdbc:mysql://localhost:3306/corpuszulu", "root", "");
         Statement st = conn.createStatement();
         ResultSet val = st.executeQuery("SELECT frequency FROM trigrams WHERE theword= '"+word+"'");
         while(val.next())
          {
             count=val.getInt("frequency");
          }
         
         conn.close();
       }
       catch (Exception e) 
       {
		  e.printStackTrace(); 
       }
       return count;
   
   }
   //Lists permutations of a string
   public static ArrayList<String> permutationList(String word)
   {
       ArrayList<String> store = new ArrayList<>();
         if (word.length() == 1) 
          {
             store.add(word);
          } 
         else if (word.length() > 1) 
         {
              int lastIndex = word.length() - 1;
              String last = word.substring(lastIndex);
              String rest = word.substring(0, lastIndex);
              store = mergePerm(permutationList(rest), last);
         }
         return store;
    }
     //Merge string permutations together
     public static ArrayList<String> mergePerm(ArrayList<String> list, String word) 
     {
          ArrayList<String> PermList = new ArrayList<>();
           // Loop through all the string in the list
          for (String s : list) 
          {
             // For each string, insert the last character to all possible postions
             // and add them to the new list
                for (int i = 0; i <= s.length(); ++i) 
                {
                    String ps = new StringBuffer(s).insert(i, word).toString();
                    PermList.add(ps);
                 }
          }
          return PermList;
   }
   //Get suggestions for transposition errors  
   public static String getSuggestion(ArrayList<String> permutationList, String word)
   {
       String bestFound;
       int BestFre=0;
       bestFound=word;
       for(int i=0;i<permutationList.size();i++)
       {
           int WordFre = getUnigramCount(permutationList.get(i));
           //System.out.println(permutationList.get(i));
           //System.out.println(WordFre);
           if(WordFre>=1)
           { 
               //System.out.println("true");
             BestFre=WordFre;
             bestFound=permutationList.get(i);
             //System.out.println(permutationList.get(i));
           }
       }
       
       if(BestFre==0)
       {
           BestFre=0;
           bestFound=word;
           ArrayList<String> strTri= new ArrayList<>();
           for(int j=0;j<permutationList.size();j++)
           {
              if(permutationList.get(j).length()>3)
              {
                strTri=WordTrigram(permutationList.get(j));
                int TriCount=0;
                for(int pos=0; pos<strTri.size();pos++)
                {
                    TriCount=TriCount+getTrigramCount(strTri.get(pos));
                }
                if(TriCount>BestFre)
                {
                    BestFre=TriCount;
                    bestFound=permutationList.get(j);
                }
              }
            }
         }
       
       if(BestFre==0)
       {
           BestFre=0;
           bestFound=word;
           ArrayList<String> strBi= new ArrayList<>();
           for(int j=0;j<permutationList.size();j++)
           {
              if(permutationList.get(j).length()>2)
              {
                strBi=WordBigram(permutationList.get(j));
                int BiCount=0;
                for(int pos=0; pos<strBi.size();pos++)
                {
                    BiCount=BiCount+getBigramCount(strBi.get(pos));
                }
                if(BiCount>BestFre)
                {
                    BestFre=BiCount;
                    bestFound=permutationList.get(j);
                }
              }
            }
         }
      //System.out.println(bestFound);
      return bestFound;
   }                                                                      
 //Presents results
   public static ArrayList<String> postprocess(String inputText, ArrayList<String> substitutionList)
   {
      String search, store;
      ArrayList<String> output=new ArrayList<>();
      StringTokenizer sInputText = new StringTokenizer(inputText);
      int numberoftokens = sInputText.countTokens();
             
            for(int i = 0; i < numberoftokens;i++) 
             {
                 search = sInputText.nextToken();
                 store = search;
                 int j =0;
                 while(j<substitutionList.size())
                 {  
                     
                     String test= substitutionList.get(j);
                     if(search.equals(test))
                     {
                         store = substitutionList.get(j+1);
                         j=substitutionList.size();
                     }
                     else
                     {
                         j=j+2;
                     }
                }
                output.add(store);
             }
              
      
      return output;
   }
   //
   public static ArrayList<String> SubList(String unfound)
   {
       String store;
       ArrayList<String> outputList=new ArrayList<>();
       StringTokenizer sInputText = new StringTokenizer(unfound);
       int numberoftokens = sInputText.countTokens();    
            for(int i =0;i < numberoftokens;i++) 
             {
                store = sInputText.nextToken();
                outputList.add(store);
                //System.out.println("First word" + store);
                outputList.add(getSuggestion(permutationList(store),store));
                //System.out.println("Second word" + getSuggestion(permutationList(store),store));
             }
             //int lenth=outputList.size();
             //for(int i=0;i<lenth;i++)
             //{
               //System.out.println(outputList.get(i));
             //}
        return outputList;  
   }
   //Commputes the difference between words
   public static int minDiff(String str1, String str2)
   {
       int firstLength=str1.length();
       int secondLength=str2.length();
       int [][]store=new int[firstLength+1][secondLength+1];
       for(int i=0;i<=firstLength;i++)
       {
           store[i][0]=i;
       }
       for(int j=0;j<=secondLength;j++)
       {
           store[0][j]=j;
       }        
       for(int i=1; i<=secondLength;i++)
       {
           for(int j=1;j<=firstLength;j++)
           {
              if(str1.charAt(i-1)==str2.charAt(j-1))
              {
                store[i][j]=store[i-1][j-1];   
                //System.out.println("THE FIRST=> "  + store[i][j]);
              }
              else
              {
                  int a=(store[i-1][j])+1;
                  int b=(store[i][j-1])+1;
                  int c=(store[i-1][j-1])+1;
                   store[i][j]=(a>b)?((a>c)?a:c):((b>c)?b:c);
                  // System.out.println("THE FIRST=> "  + store[i][j]);
                  // store[i][j]=Math.min(Math.min(a, b), c);
                   //System.out.println("THE SECOND" + store[i][j]);
              }
           }
       }
       return store[firstLength][secondLength];
   }
  //Searches for a string in a text file
   /*public static int search(String text, String filePath)throws IOException 
   {
      int count = 0;
      boolean found = false;
      String line;
      //text = text;
      FileReader fr = new FileReader(filePath);
      BufferedReader br = new BufferedReader(fr);
      while ((line = br.readLine()) != null && !found) 
      {
        int fromIndex = 0;
        int index = -1;
        while ((index = line.indexOf(text, fromIndex)) != -1) {
            count++;
            fromIndex = index + text.length();
            found=true;
        }
        

    }

    fr.close();
    br.close();

    return count;
   }*/
   public static int search(String search, String filePath) throws FileNotFoundException
   {
        boolean found = false;
        int count =0;
        String searchn;
        java.io.File file;
        file = new java.io.File(filePath);
        
             Scanner input = new Scanner(file);
             while(found!=true&& input.hasNext())
             {
                  searchn= input.next();
                  found = search.toLowerCase().equals(searchn.toLowerCase());
                  if(found)
		  { 
                   count++;   
                  }     
             }
        return count;
   }
  public static boolean errordetection(String str) throws IOException
   {
       String searchstring;
       boolean found=false;
       int fre = 0;
       double calFre=0, threshold=0.003;
       int totalW=50000;
       
       if(str.length()<3)
       {
           found=true;
           //System.out.println(str + " calculated frequency is " + calFre + " Not found ");
       }
       else
       {
           
       StringTokenizer sTok = new StringTokenizer(str.toLowerCase());
       int numberoftokens = sTok.countTokens();
       try
       {
         Class.forName("com.mysql.jdbc.Driver").newInstance(); 
         Connection conn = DriverManager.getConnection( "jdbc:mysql://localhost:3306/corpuszulu", "root", "");
         Statement st = conn.createStatement();
         for(int i = 0; i < numberoftokens;i++)
         {
               searchstring = sTok.nextToken();
               int pos =0;
               while(pos <searchstring.length())
               {
                     str = searchstring.substring(pos, pos+3);
                     //System.out.println(pos + "" + str);
                      ResultSet val = st.executeQuery("SELECT frequency FROM trigrams WHERE theword= '"+str+"'");  //escape(str)
                      
                      while(val.next())
                      {
                          fre=val.getInt("frequency");
                      }
                       
                     calFre=(double)fre/(double)totalW;
                     
                     if(calFre<threshold)
                     {
                         found=false;
                         //System.out.println(str + " calculated probability is " + calFre + " Not found ");
                         pos=searchstring.length();
                         i=numberoftokens;
                     }
                     else
                     {
                         found=true;
                         //System.out.println(str + " calculated probability is " + calFre + " Found ");
                         
                     }
                    
                     if(pos+3>=searchstring.length())
                     {
                         pos=searchstring.length();
                     }
                     pos++;
               }
           
       }
       conn.close();   
      }
       catch (Exception e) 
       {
		  e.printStackTrace(); 
       }  
   }
   return found;
}
  //Tests a test file with the spellchecker
  public static void testing(String testFile) throws FileNotFoundException, IOException
  {
        boolean found = false;
        int count;
        String searchn, teststring;
        java.io.File file;
        file = new java.io.File(testFile);
        FileWriter f = new FileWriter("results.txt");                                                                                         
        Scanner input = new Scanner(file);
        while(found!=true&& input.hasNext())
        {
           searchn= input.next();
           StringTokenizer testwords= new StringTokenizer(searchn);
           int numberoftokens = testwords.countTokens();
           for(int i =0;i<numberoftokens;i++)
           {
            teststring = testwords.nextToken();
            boolean check=errordetection(teststring); 
            if(check)
            {
                count =1;
                f.write(count + "\r\n");
            }
            else
            {
                count =0;
                f.write(count + "\r\n");
            }
       
         }
        }
        f.close();
  }
  public static void bcorpus() throws IOException
{
        boolean found = false;
        int count;
        String searchn, teststring;
        java.io.File file1, file2;
        file1 = new java.io.File("inputa.txt");
        file2 = new java.io.File("inputb.txt");
        FileWriter f = new FileWriter("langacorpus.txt");
        Scanner input1 = new Scanner(file1);
        Scanner input2 = new Scanner(file2);
        while(input1.hasNext() && input2.hasNextInt())
        {
           searchn= input1.next();
           count = input2.nextInt();
           for(int i =0;i<count;i++)
           {
                f.write(searchn + " ");
           }
           
        }
        f.close();
  }
}
  

   
  
